header {* Induction Principles *}

theory Induct imports CAN
begin

theorem induct_node_zone:
"\<lbrakk> P {}; \<And>n Z. \<lbrakk>\<And>Z'. ZoneSize C Z'=n\<Longrightarrow>P Z'; ZoneSize C Z=Suc n\<rbrakk> \<Longrightarrow> P Z \<rbrakk>
   \<Longrightarrow> P Z"
apply (subgoal_tac " \<And> n. \<forall> Z.  card (NodesInZone C Z) = n \<longrightarrow> P Z")
apply force
apply (induct_tac n)
apply auto
(*1*)
apply (subgoal_tac "Z={}");
 apply simp;
apply (rule_tac C=C in intersects_empty);
apply ( subgoal_tac "finite  (NodesInZone C Z)");
 apply (drule Finite_Set.card_0_eq);
 apply auto;
(*1*)
apply (subgoal_tac "Rep_CAN C\<in>CAN")
 apply (force simp: CAN_def  CAN_Nodes_def);
apply (rule Rep_CAN);
done

text{*MARK*}
theorem induct_node_zone_2:
"\<lbrakk> P {};
  \<And>Z. (P Z\<longrightarrow>(\<forall>N\<in>CAN_Nodes C. N\<notin>NodesInZone C Z\<longrightarrow>
           (\<forall>Z'.(NodesInZone C Z'={N}\<longrightarrow> P (Z\<union>Z')))))  \<rbrakk>
  \<Longrightarrow> P Z"
apply (erule_tac P=P in induct_node_zone)
apply auto
apply (subgoal_tac "\<exists>N\<in>CAN_Nodes C. \<exists> Z0 Z1. Z=Z0\<union>Z1\<and> NodesInZone C Z1={N}\<and>card (NodesInZone C Z0)=n \<and>N\<notin>NodesInZone C Z0")
apply auto
apply (simp add: Finite_Set.card_Suc_eq)
apply clarify
apply (rule_tac x=b in bexI)
apply (rule_tac x="Z \<inter> (\<Union>  {CAN_Zones C n|n. n\<in>B})" in exI)
apply (rule_tac x="Z \<inter> CAN_Zones C b" in exI)
apply simp
apply (simp only: insert_compr)
apply (auto simp: intersects_def)
apply (frule_tac C=C in NodesInZone_exI)
apply auto
apply (subgoal_tac "N\<in>B")
apply blast
apply (subgoal_tac "N\<noteq>b")
apply (auto simp: intersects_def)
apply (rule ccontr)
apply (drule_tac N'=b in disjoint_zones)
apply (auto simp: intersects_def)

apply (rule_tac f=card in arg_cong)
apply auto
apply (subgoal_tac "n=x")
apply simp
apply (rule inc_single_zone_2, auto simp: intersects_def)
apply (subgoal_tac "x\<in>{x. x = b \<or> x \<in> B}")
apply (drule sym, simp)
apply clarify
apply (rule_tac x=tup in exI)
apply auto
apply (subgoal_tac "n=b")
apply force
apply (rule inc_single_zone_2, auto simp: intersects_def)
apply (frule_tac C=C in NodesInZone_exI)
apply (auto simp: intersects_def)
done

abbreviation Decomposable:: "CAN \<Rightarrow>(CAN\<Rightarrow>Zone\<Rightarrow>bool)\<Rightarrow>bool"
where "Decomposable C G  \<equiv> (\<forall> Z. ZoneSize C Z = 0 \<longrightarrow> G C Z) \<and>
                          (\<forall> Z. ZoneSize C Z >0 \<longrightarrow> (G C Z \<longrightarrow>( \<exists> Z' Z''. Z=Z'\<union>Z''\<and> G C Z'\<and>
                               ZoneSize C Z' = ZoneSize C Z - 1\<and>ZoneSize C Z''=1)))"

theorem induct_node_zone_3:"
\<lbrakk> Decomposable C G; P {}; 
  \<forall> Z' n. ZoneSize C Z' = Suc n \<longrightarrow>((\<forall> Z. (ZoneSize C Z = n \<and> G C Z) \<longrightarrow> P Z) \<and> G C Z' \<longrightarrow> P Z')\<rbrakk> 
  \<Longrightarrow> G C Z \<longrightarrow> P Z"
  (is "\<lbrakk>?decomposable; ?P0; ?Pn \<rbrakk> \<Longrightarrow> ?GCZ \<longrightarrow> ?PZ")
proof
assume "?decomposable" "?P0" "?Pn" "?GCZ"
let ?NN = "ZoneSize C Z"
from `?decomposable` `?P0` `?Pn` `?GCZ` show "?PZ"
  apply auto
  apply (insert induct_node_zone)
  apply (drule_tac x="\<lambda>zz. ((ZoneSize C zz\<le>?NN \<and> G C zz )\<longrightarrow> P zz)" in meta_spec)
  apply (drule_tac x=C in meta_spec)
  apply (drule_tac x=Z in meta_spec)
  apply auto
done
qed



end